
var helper = {
	toRad: function (deg) {
		return deg * Math.PI / 180;
	}
};

var clockAng
	
function RadialBar(ctx, config) {
	this.ctx = ctx;
	this.config = config;
	this.PERCENT_DEG = 360 / 100;
	this.newDeg = 0.01;
	
	this.ctx = ctx;
		
	// progress bar
	this.isStop = false;
	this.progress = config.progress || 0;
	this.degProgress = this.progress * this.PERCENT_DEG;
	this.isShowInfoText = config.isShowInfoText == null ? true : config.isShowInfoText;

	this._roundProgress = function () {
		this.degProgress = Math.ceil(this.degProgress * 100) / 100;
		this.progress = Math.ceil(this.progress * 100) / 100;
	};

	this.styles = function () {
		// pos
		this.x = this.config.x || 0;
		this.y = this.config.y || 0;

		// style
		this.radius = config.radius == null ? 50 : this.config.radius;
		this.lineWidth = config.lineWidth == null ? 10 : this.config.lineWidth;

		this.angle = this.config.angle || 0;

		this.lineFill = this.config.lineFill || '#fff';

		this.backLineFill = this.config.backLineFill || 'transparent';
		this.bgFill = this.config.bgFill;

		this.infoStyle = this.config.infoStyle || '24px Arial';
		this.infoColor = this.config.infoColor || '#000';

		this.isStop = this.config.isStop == null ? false : this.config.isStop;
	};
	this.styles();

	this.set = function (p) {
		if (!this.isStop) {
			this.saveProgress = this.progress;
			this.degProgress = p * this.PERCENT_DEG;
			this.progress = p;

			this._roundProgress();
		}
	};
	this.subtract = function (p) {
		if (!this.isStop) {
			this.saveProgress = this.progress;
			this.degProgress -= p * this.PERCENT_DEG;
			this.progress -= p;

			this._roundProgress();

			if (this.progress < 0) {
				this.progress = 0;
				this.degProgress = 0.01;
			}
		}
	};
	this.add = function  (p) {
		if (!this.isStop) {
			this.saveProgress = this.progress;
			this.degProgress += p * this.PERCENT_DEG;
			this.progress += p;

			this._roundProgress();
			
			if (this.progress > 100) {
				this.progress = 100;
				this.degProgress = 359.99;
			}
			
			 if(this.newDeg >= 359){
				this.newDeg = 359.99;
				this.progress = 100;
				this.degProgress = 359.99;
				clockAng = this.degProgress;
				console.log(this.progress);
				
				timerAng(this.progress);
			}
		}
	};

	this.get = function (p) {
		return Math.floor(this.progress);
	};

	this.showInfoText = function (p) {
		this.ctx.save();
		this.ctx.fillStyle = this.infoColor;
		this.ctx.textAlign = 'center';
		this.ctx.textBaseline = 'middle';
		this.ctx.font = this.infoStyle;

		this.ctx.fillText(this.get() + '%', this.x, this.y);
		this.ctx.restore();
	};
	var flag1 = true;
	this.update = function () {
		this.ctx.save();
		this.ctx.translate(this.x, this.y);
		this.ctx.rotate(helper.toRad(-90 + this.angle));

		this.ctx.lineWidth = this.lineWidth;

		this.ctx.fillStyle = this.config.bgFill;
		this.ctx.beginPath();
		this.ctx.arc(0, 0, this.radius, 0, 2 * Math.PI);
		this.ctx.fill();

		this.ctx.strokeStyle = this.config.backLineFill;
		this.ctx.beginPath();
		this.ctx.arc(0, 0, this.radius, 0, 2 * Math.PI);
		this.ctx.stroke();

		this.ctx.strokeStyle = this.config.lineFill;
		this.ctx.beginPath();
		//this.ctx.arc(0, 0, this.radius, 0, helper.toRad(this.degProgress), true);
		this.ctx.arc(0, 0, this.radius, 0, helper.toRad(this.newDeg), true);
		this.ctx.stroke();

		this.ctx.restore();

		if (this.isShowInfoText) this.showInfoText();
				
		/* if(this.isStop){
			this.newDeg = (360/(newSecond-275)*2.14);
			return;
		} */
		if(startTimeFrom != null && flag1){
			this.newDeg = (360/newSecond)*(newSecond-startTimeFrom);
			flag1 = false;
		}

		this.newDeg += (360/newSecond);
	};
}